#include <stdio.h>

void main(){
    int n, m, i, c, j;
    scanf("%i%i", &n, &m);
    int* b, *a;
    b = malloc(m * sizeof(int));
    a = malloc(n * sizeof(int));
    for(i = 0; i < m; i++)
        scanf("%i", &b[i]);
    for(i = 0; i < n; i++)
    	a[i] = i + 1;
    scanf("%i", &c);
    for(i = 0; i < n - m; i++){
    	for (j=0; j<m; j++)
        	a[i + b[j]] = a[i + j];
    }
    printf("998244352"); //Nmp
}